package edu.dhbw.pv;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.LinkedBlockingQueue;

public class Uebung5 {

    public static void main(String[] args) {
        int tasks = 5;
        int ctasks = 10;
        //BlockingQueue<Arbeit> stapel = new LinkedBlockingQueue<Arbeit>();
        BlockingQueue<Arbeit> stapel = new ArrayBlockingQueue<Arbeit>(100);
        ExecutorService pool = Executors.newCachedThreadPool();
        Future[] prods = new Future[tasks];
        Future[] cons = new Future[ctasks];
        for (int i = 0; i < tasks; i++ ) {
            prods[i] = pool.submit( new Producer(i,stapel) );
            
        }
        for (int i = 0; i < ctasks; i++) {
            cons[i] = pool.submit( new Consumer(i,stapel) );
        }
        for (int i= 0; i < tasks; i++) {
            try {
                prods[i].get();
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        //for (int i= 0; i < ctasks; i++) {
            try {
                stapel.put( new Ende(-1) );
            } catch (InterruptedException e1) {
                e1.printStackTrace();
            }
        //}
        for (int i= 0; i < ctasks; i++) {
            try {
                cons[i].get();
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        pool.shutdown();
    }
}
class Producer implements Runnable {
    int me;
    BlockingQueue<Arbeit> stapel;
    public Producer(int i, BlockingQueue<Arbeit> q) {
        me = i;
        stapel = q;
        System.out.println("Producer("+me+") create");
    }
    public void run() {
        for (int i = 0; i < 200; i++) {
             try {
                stapel.put( new Arbeit(100*me+i) );
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        System.out.println("Producer("+me+") end");
    }
}
class Consumer<V> implements Callable<V> {
    int me;
    BlockingQueue<Arbeit> stapel;
    public Consumer(int i, BlockingQueue<Arbeit> q) {
        me = i;
        stapel = q;
        System.out.println("Consumer("+me+") create");
    }
    public V call() {
        V ret = null;
        Arbeit x = null;
        for(int i = 0; /*i < 100*/; i++) {
            try {
                x = stapel.take();
                if (x instanceof Ende) {
                    stapel.put(x);
                    break;
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        System.out.println("take = " + x + ", Consumer("+me+") end");
        return ret;
    }
}
class Arbeit {
    int nummer; 
    public Arbeit(int i) {
        nummer = i;
    }
    public String toString() {
        return "Arbeit("+nummer+")";
    }
}
class Ende extends Arbeit {
    public Ende(int i) {
        super(i);
    }
}