package edu.dhbw.pv;

import mpi.MPI;
import mpi.MPIException;
import mpi.Status;

/**
 */
public class Uebung7 {

    static public void main(String[] args) throws MPIException {
        MPI.Init(args);

        int me = MPI.COMM_WORLD.Rank();
        int size = MPI.COMM_WORLD.Size();
        System.out.println("Running on node " + me + " of " + size + " total nodes");
        
        if (me == 0) {
            char[] message = ("Hello, from " + me + "." ).toCharArray();
            MPI.COMM_WORLD.Send(message, 0, message.length, MPI.CHAR, 1, 99);
            message = new char[30];
            Status stat = MPI.COMM_WORLD.Recv(message, 0, message.length, MPI.CHAR, size-1, 99);
            int count = stat.Get_count(MPI.CHAR); // stat.count
            String msg = new String(message, 0, count);
            System.out.println("received '" + msg + "' at node " + me + ", Status.count = " + count);
        } else {
            char[] message = new char[20];
            Status stat = MPI.COMM_WORLD.Recv(message, 0, message.length, MPI.CHAR, me-1, 99);
            int count = stat.Get_count(MPI.CHAR); // stat.count
            String msg = new String(message, 0, count);
            System.out.println("received '" + msg + "' at node " + me + ", Status.count = " + count);
            message = ("Hello back, from " + me + "." ).toCharArray();
            int i = me+1;
            if (me == size-1) {
                i = 0;
            }
            MPI.COMM_WORLD.Send(message, 0, message.length, MPI.CHAR, i, 99);
            System.out.println("done send at " + me);
        }
        
        MPI.Finalize();
    }
}
